unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, ACTIVECDXLib_TLB;

type
  TForm1 = class(TForm)
    CDXVisual: TCDXVisual;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    Splash: longint;
    procedure PaintBitmap;
    procedure CDXError(msg:PChar);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.PaintBitmap;
begin
  CDXVisual.DrawFast(CDXVisual.GetBack, 0, 0, Splash);
  CDXVisual.Flip;
end;

procedure TForm1.CDXError(msg:PChar);
begin
  MessageBox(0, msg, 'CDX Error', MB_OK);
  CDXVisual.Destroy;
  Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  if not CDXVisual.CreateWindowed(Handle, 640, 480) then
    CDXError('Failed creating windowed CDX');
  Splash := CDXVisual.CreateSurface4('c:\cdx\acdx\examples\res\splash.bmp', 2);
  if Splash = 0 then
    CDXError('Failed loading c:\cdx\acdx\examples\res\splash.bmp');
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  PaintBitmap;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  PaintBitmap;
end;

end.
