unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ACTIVECDXLib_TLB, OleCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    CDXVisual: TCDXVisual;
    CDXDraw: TCDXDraw;
    Stop: TButton;
    Line: TButton;
    Rect: TButton;
    Circle: TButton;
    Exit: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure LineClick(Sender: TObject);
    procedure RectClick(Sender: TObject);
    procedure CircleClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    Demo:integer;
    procedure CDXError(msg:PChar);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.CDXError(msg:PChar);
begin
  MessageBox(0, msg, 'CDX Error', MB_OK);
  CDXVisual.Destroy;
  Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  if not CDXVisual.CreateWindowed(Handle, 640, 480) then
    CDXError('Failed creating windowed CDX');
  Demo:=0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  CDXVisual.Destroy;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
  Demo:=0;
  CDXVisual.Fill(CDXVisual.GetBack, 0);
end;

procedure TForm1.LineClick(Sender: TObject);
begin
  Demo:=1;
  CDXVisual.Fill(CDXVisual.GetBack, 0);
end;

procedure TForm1.RectClick(Sender: TObject);
begin
  Demo:=2;
  CDXVisual.Fill(CDXVisual.GetBack, 0);
end;

procedure TForm1.CircleClick(Sender: TObject);
begin
  Demo:=3;
  CDXVisual.Fill(CDXVisual.GetBack, 0);
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var BackBuffer:longint;
    x1, y1, x2, y2, radius, color:longint;
begin
  {Exit if no button selected}
  if demo <> 0 then
  begin
    {Get and lock the backbuffer}
    BackBuffer := CDXVisual.GetBack;
    CDXVisual.Lock (BackBuffer);

    {Generate random position and color}
    x1 := Random(640);
    y1 := Random(480);
    x2 := Random(640);
    y2 := Random(480);
    radius := Random(50);
    color := Random(60000);

    {Draw something}
    Case Demo of
      1 : CDXDraw.Line2(BackBuffer, x1, y1, x2, y2, color);
      2 : CDXDraw.Rect(BackBuffer, x1, y1, x2, y2, color);
      3 : CDXDraw.FillCircle(BackBuffer, x1, y1, radius, color);
    End;

    {Unlock and flip}
    CDXVisual.Unlock (BackBuffer);
    CDXVisual.Flip;
  end
end;

end.
