#if !defined(AFX_CDXVISUALCTL_H__1252053C_29BC_11D0_A2B7_CFA54B507249__INCLUDED_)
#define AFX_CDXVISUALCTL_H__1252053C_29BC_11D0_A2B7_CFA54B507249__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// CDXVisualCtl.h : Declaration of the CDXVisualCtrl ActiveX Control class.

#define CDXINCLUDEALL
#include <cdx.h>

/////////////////////////////////////////////////////////////////////////////
// CDXVisualCtrl : See CDXVisualCtl.cpp for implementation.

class CDXVisualCtrl : public COleControl
{
	DECLARE_DYNCREATE(CDXVisualCtrl)

// Constructor
public:
	CDXVisualCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDXVisualCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL m_bFullScreen;
	CDXScreen* Screen;
	~CDXVisualCtrl();

	DECLARE_OLECREATE_EX(CDXVisualCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CDXVisualCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CDXVisualCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CDXVisualCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CDXVisualCtrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CDXVisualCtrl)
	afx_msg BOOL CreateFullScreen(OLE_HANDLE hWnd, OLE_XSIZE_PIXELS width, OLE_YSIZE_PIXELS height, short bpp);
	afx_msg BOOL CreateWindowed(OLE_HANDLE hWnd, OLE_XSIZE_PIXELS width, OLE_YPOS_PIXELS height);
	afx_msg long Flip();
	afx_msg void Destroy();
	afx_msg OLE_HANDLE CreateSurface();
	afx_msg OLE_HANDLE CreateSurface2(OLE_HANDLE surface);
	afx_msg OLE_HANDLE CreateSurface3(long width, long height, short memoryType);
	afx_msg OLE_HANDLE CreateSurface4(LPCTSTR szFilename, short memoryType);
	afx_msg BOOL CreateFullScreenVGA(OLE_HANDLE hWnd, OLE_XSIZE_PIXELS width, OLE_YSIZE_PIXELS height, short bpp);
	afx_msg OLE_HANDLE GetFront();
	afx_msg OLE_HANDLE GetBack();
	afx_msg long Fill(OLE_HANDLE destSurface, OLE_COLOR color);
	afx_msg long DrawFast(OLE_HANDLE destSurface, long x, long y, OLE_HANDLE srcSurface);
	afx_msg OLE_HANDLE GetDC(OLE_HANDLE surface);
	afx_msg void ReleaseDC(OLE_HANDLE surface);
	afx_msg void DestroySurface(OLE_HANDLE surface);
	afx_msg long Lock(OLE_HANDLE surface);
	afx_msg long Unlock(OLE_HANDLE surface);
	afx_msg BOOL LoadPalette(LPCTSTR szFilename);
	afx_msg long Flip2(BOOL bVSync, BOOL bFlipWithStretch, BOOL bDisplayFPS);
	afx_msg void SetColor(long col, long r, long g, long b);
	afx_msg void GetColor(long col, long FAR* r, long FAR* g, long FAR* b);
	afx_msg void GrayScale();
	afx_msg void SetPalette(long start, long count, LPUNKNOWN lpPaletteEntry);
	afx_msg void GetPalette(long start, long count, LPUNKNOWN lpPaletteEntry);
	afx_msg void FillPalette(long r, long g, long b);
	afx_msg void FadeIn(long delay, LPUNKNOWN lpPaletteEntry);
	afx_msg void FadeOut(long delay);
	afx_msg void FadeTo(long r, long g, long b, long delay);
	afx_msg LPUNKNOWN GetDD();
	afx_msg LPUNKNOWN GetPalette2();
	afx_msg long GetNumberOfVideoModes();
	afx_msg BOOL GetVideoModeInformation(long index, long FAR* width, long FAR* height, long FAR* bpp);
	afx_msg BOOL CheckIfVideoModeExists(long width, long height, long bpp);
	afx_msg long WaitForVerticalBlank();
	afx_msg void CreateBackBufferInVRAM(BOOL flag);
	afx_msg void SetTripleBuffering(BOOL flag);
	afx_msg BOOL GetTripleBuffering();
	afx_msg OLE_COLOR MakeColor(OLE_COLOR color);
	afx_msg OLE_COLOR MakeColor2(OLE_COLOR color, OLE_HANDLE surfaceRef);
	afx_msg BOOL SelectDriver(long index);
	afx_msg void FadeToBlack(long duration);
	afx_msg void FadeToSource(long duration);
	afx_msg BOOL LoadAlphaMask(OLE_HANDLE surface, LPCTSTR szFilename);
	afx_msg void SetFont(OLE_HANDLE surface);
	afx_msg void ChangeFont(OLE_HANDLE surface, LPCTSTR szFilename, long width, long height);
	afx_msg void ChangeFont2(OLE_HANDLE surface, LPCTSTR szFilename, long width, long height, long attributes);
	afx_msg void SetColorKey(OLE_HANDLE surface);
	afx_msg void SetColorKey2(OLE_HANDLE surface, OLE_COLOR color);
	afx_msg void SetDest(OLE_HANDLE surface, long x1, long y1, long x2, long y2);
	afx_msg void SetSrc(OLE_HANDLE surface, long x1, long y1, long x2, long y2);
	afx_msg long Draw(OLE_HANDLE destSurface, OLE_HANDLE srcSurface);
	afx_msg long DrawTrans(OLE_HANDLE destSurface, long x, long y, OLE_HANDLE srcSurface);
	afx_msg long DrawClipped(OLE_HANDLE destSurface, long x, long y, OLE_HANDLE srcSurface, LPUNKNOWN lpClipRect);
	afx_msg long DrawWindowed(OLE_HANDLE destSurface, OLE_HANDLE srcSurface);
	afx_msg long DrawScaled(OLE_HANDLE destSurface, long x, long y, OLE_HANDLE srcSurface, float factor);
	afx_msg long DrawScaled2(OLE_HANDLE destSurface, long x, long y, OLE_HANDLE srcSurface, long width, long height);
	afx_msg long DrawHFlip(OLE_HANDLE destSurface, long x, long y, OLE_HANDLE srcSurface);
	afx_msg long DrawVFlip(OLE_HANDLE destSurface, long x, long y, OLE_HANDLE srcSurface);
	afx_msg void DrawRotated(OLE_HANDLE destSurface, long x, long y, OLE_HANDLE srcSurface, double angle);
	afx_msg void SetClipRect(OLE_HANDLE surface, LPUNKNOWN lpClipRect);
	afx_msg void GetClipRect(OLE_HANDLE surface, LPUNKNOWN lpClipRect);
	afx_msg void EnableTexture(OLE_HANDLE surface, BOOL flag);
	afx_msg long GetScreenWidth();
	afx_msg long GetScreenHeight();
	afx_msg long GetScreenBPP();
	afx_msg long GetWidth(OLE_HANDLE surface);
	afx_msg long GetHeight(OLE_HANDLE surface);
	afx_msg long GetPitch(OLE_HANDLE surface);
	afx_msg LPUNKNOWN GetSurfaceBytesPointer(OLE_HANDLE surface);
	afx_msg LPUNKNOWN GetDDS(OLE_HANDLE surface);
	afx_msg void Restore(OLE_HANDLE surface);
	afx_msg void TextXY(OLE_HANDLE surface, long x, long y, LPCTSTR text, OLE_COLOR color);
	afx_msg void DrawText(OLE_HANDLE surface, LPCTSTR text, OLE_COLOR color, LPUNKNOWN lpRect);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CDXVisualCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CDXVisualCtrl)
	dispidCreateFullScreen = 1L,
	dispidCreateWindowed = 2L,
	dispidFlip = 3L,
	dispidDestroy = 4L,
	dispidCreateSurface = 5L,
	dispidCreateSurface2 = 6L,
	dispidCreateSurface3 = 7L,
	dispidCreateSurface4 = 8L,
	dispidCreateFullScreenVGA = 9L,
	dispidGetFront = 10L,
	dispidGetBack = 11L,
	dispidFill = 12L,
	dispidDrawFast = 13L,
	dispidGetDC = 14L,
	dispidReleaseDC = 15L,
	dispidDestroySurface = 16L,
	dispidLock = 17L,
	dispidUnlock = 18L,
	dispidLoadPalette = 19L,
	dispidFlip2 = 20L,
	dispidSetColor = 21L,
	dispidGetColor = 22L,
	dispidGrayScale = 23L,
	dispidSetPalette = 24L,
	dispidGetPalette = 25L,
	dispidFillPalette = 26L,
	dispidFadeIn = 27L,
	dispidFadeOut = 28L,
	dispidFadeTo = 29L,
	dispidGetDD = 30L,
	dispidGetPalette2 = 31L,
	dispidGetNumberOfVideoModes = 32L,
	dispidGetVideoModeInformation = 33L,
	dispidCheckIfVideoModeExists = 34L,
	dispidWaitForVerticalBlank = 35L,
	dispidCreateBackBufferInVRAM = 36L,
	dispidSetTripleBuffering = 37L,
	dispidGetTripleBuffering = 38L,
	dispidMakeColor = 39L,
	dispidMakeColor2 = 40L,
	dispidSelectDriver = 41L,
	dispidFadeToBlack = 42L,
	dispidFadeToSource = 43L,
	dispidLoadAlphaMask = 44L,
	dispidSetFont = 45L,
	dispidChangeFont = 46L,
	dispidChangeFont2 = 47L,
	dispidSetColorKey = 48L,
	dispidSetColorKey2 = 49L,
	dispidSetDest = 50L,
	dispidSetSrc = 51L,
	dispidDraw = 52L,
	dispidDrawTrans = 53L,
	dispidDrawClipped = 54L,
	dispidDrawWindowed = 55L,
	dispidDrawScaled = 56L,
	dispidDrawScaled2 = 57L,
	dispidDrawHFlip = 58L,
	dispidDrawVFlip = 59L,
	dispidDrawRotated = 60L,
	dispidSetClipRect = 61L,
	dispidGetClipRect = 62L,
	dispidEnableTexture = 63L,
	dispidGetScreenWidth = 64L,
	dispidGetScreenHeight = 65L,
	dispidGetScreenBPP = 66L,
	dispidGetWidth = 67L,
	dispidGetHeight = 68L,
	dispidGetPitch = 69L,
	dispidGetSurfaceBytesPointer = 70L,
	dispidGetDDS = 71L,
	dispidRestore = 72L,
	dispidTextXY = 73L,
	dispidDrawText = 74L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CDXVISUALCTL_H__1252053C_29BC_11D0_A2B7_CFA54B507249__INCLUDED)
